Overview | Package | Class | Tree | Deprecated | Index | Help | Weka's home
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## weka.filters.supervised.instance
Class Resample

    java.lang.Object
      weka.filters.Filter
          weka.filters.supervised.instance.Resample

All Implemented Interfaces:
  java.io.Serializable, OptionHandler, SupervisedFilter

    public class Resample

extends Filter
implements SupervisedFilter, OptionHandler

Produces a random subsample of a dataset using sampling with replacement. The original dataset must fit entirely in memory. The number of instances in the generated dataset may be specified. The dataset must have a nominal class attribute. If not, use the unsupervised version. The filter can be made to maintain the class distribution in the subsample, or to bias the class distribution toward a uniform distribution. When used in batch mode, subsequent batches are not resampled. Valid options are:

-S num
Specify the random number seed (default 1).

-B num
Specify a bias towards uniform class distribution. 0 = distribution in input data, 1 = uniform class distribution (default 0).

-Z percent
Specify the size of the output dataset, as a percentage of the input dataset (default 100).

Version:
  $Revision: 1.4.2.1 $
Author:
  Len Trigg (len@reeltwo.com)
See Also:
  Serialized Form

Constructor Summary
`Resample()`

Method Summary
`boolean` | `batchFinished()` Signify that this batch of input to the filter is finished.
`java.lang.String` | `biasToUniformClassTipText()` Returns the tip text for this property
`double` | `getBiasToUniformClass()` Gets the bias towards a uniform class.
`java.lang.String[]` | `getOptions()` Gets the current settings of the filter.
`int` | `getRandomSeed()` Gets the random number seed.
`double` | `getSampleSizePercent()` Gets the subsample size as a percentage of the original set.
`java.lang.String` | `globalInfo()` Returns a string describing this filter
`boolean` | `input(Instance instance)` Input an instance for filtering.
`java.util.Enumeration` | `listOptions()` Returns an enumeration describing the available options.
`static void` | `main(java.lang.String[] argv)` Main method for testing this class.
`java.lang.String` | `randomSeedTipText()` Returns the tip text for this property
`java.lang.String` | `sampeSizePercentTipText()` Returns the tip text for this property
`void` | `setBiasToUniformClass(double newBiasToUniformClass)` Sets the bias towards a uniform class.
`boolean` | `setInputFormat(Instances instanceInfo)` Sets the format of the input instances.
`void` | `setOptions(java.lang.String[] options)` Parses a list of options for this object.
`void` | `setRandomSeed(int newSeed)` Sets the random number seed.
`void` | `setSampleSizePercent(double newSampleSizePercent)` Sets the size of the subsample, as a percentage of the original set.

Methods inherited from class weka.filters.Filter
`batchFilterFile, filterFile, getOutputFormat, inputFormat, isOutputFormatDefined, numPendingOutput, output, outputFormat, outputPeek, useFilter`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### Resample

    public Resample()

Method Detail

### globalInfo

    public java.lang.String globalInfo()

  Returns a string describing this filter

  Returns:
    a description of the filter suitable for displaying in the explorer/experimenter gui

### listOptions

    public java.util.Enumeration listOptions()

  Returns an enumeration describing the available options.

  Specified by:
    `listOptions` in interface `OptionHandler`
  Returns:
    an enumeration of all the available options.

### setOptions

    public void setOptions(java.lang.String[] options)
                    throws java.lang.Exception

  Parses a list of options for this object. Valid options are:

  -S num
  Specify the random number seed (default 1).

  -B num
  Specify a bias towards uniform class distribution. 0 = distribution in input data, 1 = uniform class distribution (default 0).

  -Z percent
  Specify the size of the output dataset, as a percentage of the input dataset (default 100).

  Specified by:
    `setOptions` in interface `OptionHandler`
  Parameters:
    `options` - the list of options as an array of strings
  Throws:
    `java.lang.Exception` - if an option is not supported

### getOptions

    public java.lang.String[] getOptions()

  Gets the current settings of the filter.

  Specified by:
    `getOptions` in interface `OptionHandler`
  Returns:
    an array of strings suitable for passing to setOptions

### biasToUniformClassTipText

    public java.lang.String biasToUniformClassTipText()

  Returns the tip text for this property

  Returns:
    tip text for this property suitable for displaying in the explorer/experimenter gui

### getBiasToUniformClass

    public double getBiasToUniformClass()

  Gets the bias towards a uniform class. A value of 0 leaves the class distribution as-is, a value of 1 ensures the class distributions are uniform in the output data.

  Returns:
    the current bias

### setBiasToUniformClass

    public void setBiasToUniformClass(double newBiasToUniformClass)

  Sets the bias towards a uniform class. A value of 0 leaves the class distribution as-is, a value of 1 ensures the class distributions are uniform in the output data.

  Parameters:
    `newBiasToUniformClass` - the new bias value, between 0 and 1.

### randomSeedTipText

    public java.lang.String randomSeedTipText()

  Returns the tip text for this property

  Returns:
    tip text for this property suitable for displaying in the explorer/experimenter gui

### getRandomSeed

    public int getRandomSeed()

  Gets the random number seed.

  Returns:
    the random number seed.

### setRandomSeed

    public void setRandomSeed(int newSeed)

  Sets the random number seed.

  Parameters:
    `newSeed` - the new random number seed.

### sampeSizePercentTipText

    public java.lang.String sampeSizePercentTipText()

  Returns the tip text for this property

  Returns:
    tip text for this property suitable for displaying in the explorer/experimenter gui

### getSampleSizePercent

    public double getSampleSizePercent()

  Gets the subsample size as a percentage of the original set.

  Returns:
    the subsample size

### setSampleSizePercent

    public void setSampleSizePercent(double newSampleSizePercent)

  Sets the size of the subsample, as a percentage of the original set.

  Parameters:
    `newSampleSizePercent` - the subsample set size, between 0 and 100.

### setInputFormat

    public boolean setInputFormat(Instances instanceInfo)
                           throws java.lang.Exception

  Sets the format of the input instances.

  Overrides:
    `setInputFormat` in class `Filter`
  Parameters:
    `instanceInfo` - an Instances object containing the input instance structure (any instances contained in the object are ignored - only the structure is required).
  Returns:
    true if the outputFormat may be collected immediately
  Throws:
    `java.lang.Exception` - if the input format can't be set successfully

### input

    public boolean input(Instance instance)

  Input an instance for filtering. Filter requires all training instances be read before producing output.

  Overrides:
    `input` in class `Filter`
  Parameters:
    `instance` - the input instance
  Returns:
    true if the filtered instance may now be collected with output().
  Throws:
    `java.lang.IllegalStateException` - if no input structure has been defined

### batchFinished

    public boolean batchFinished()

  Signify that this batch of input to the filter is finished. If the filter requires all instances prior to filtering, output() may now be called to retrieve the filtered instances.

  Overrides:
    `batchFinished` in class `Filter`
  Returns:
    true if there are instances pending output
  Throws:
    `java.lang.IllegalStateException` - if no input structure has been defined

### main

    public static void main(java.lang.String[] argv)

  Main method for testing this class.

  Parameters:
    `argv` - should contain arguments to the filter: use -h for help

Overview | Package | Class | Tree | Deprecated | Index | Help | Weka's home
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD